diff --git a/src/include/lwip/apps/mdns.h b/src/include/lwip/apps/mdns.h
index 20d7ee2a2..077bd45d6 100644
--- a/src/include/lwip/apps/mdns.h
+++ b/src/include/lwip/apps/mdns.h
@@ -32,6 +32,7 @@
  * This file is part of the lwIP TCP/IP stack.
  *
  * Author: Erik Ekman <erik@kryo.se>
+ * Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
  *
  */
 
@@ -73,11 +74,11 @@ void mdns_resp_init(void);
 
 void mdns_resp_register_name_result_cb(mdns_name_result_cb_t cb);
 
-err_t mdns_resp_add_netif(struct netif *netif, const char *hostname, u32_t dns_ttl);
+err_t mdns_resp_add_netif(struct netif *netif, const char *hostname);
 err_t mdns_resp_remove_netif(struct netif *netif);
 err_t mdns_resp_rename_netif(struct netif *netif, const char *hostname);
 
-s8_t  mdns_resp_add_service(struct netif *netif, const char *name, const char *service, enum mdns_sd_proto proto, u16_t port, u32_t dns_ttl, service_get_txt_fn_t txt_fn, void *txt_userdata);
+s8_t  mdns_resp_add_service(struct netif *netif, const char *name, const char *service, enum mdns_sd_proto proto, u16_t port, service_get_txt_fn_t txt_fn, void *txt_userdata);
 err_t mdns_resp_del_service(struct netif *netif, s8_t slot);
 err_t mdns_resp_rename_service(struct netif *netif, s8_t slot, const char *name);
 
@@ -96,6 +97,9 @@ void mdns_resp_announce(struct netif *netif);
  */
 #define mdns_resp_netif_settings_changed(netif) mdns_resp_announce(netif)
 
+struct mdns_host* netif_mdns_data(struct netif *netif);
+struct udp_pcb* get_mdns_pcb(void);
+
 #endif /* LWIP_MDNS_RESPONDER */
 
 #ifdef __cplusplus
diff --git a/src/include/lwip/apps/mdns_domain.h b/src/include/lwip/apps/mdns_domain.h
new file mode 100644
index 000000000..941ce63c5
--- /dev/null
+++ b/src/include/lwip/apps/mdns_domain.h
@@ -0,0 +1,75 @@
+/**
+ * @file
+ * MDNS responder - domain related functionalities 
+ */
+
+ /*
+ * Copyright (c) 2015 Verisure Innovation AB
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without modification,
+ * are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
+ * SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
+ * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
+ * OF SUCH DAMAGE.
+ *
+ * This file is part of the lwIP TCP/IP stack.
+ *
+ * Author: Erik Ekman <erik@kryo.se>
+ * Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
+ *
+ */
+
+#ifndef LWIP_HDR_APPS_MDNS_DOMAIN_H
+#define LWIP_HDR_APPS_MDNS_DOMAIN_H
+
+#include "lwip/apps/mdns_opts.h"
+#include "lwip/apps/mdns_priv.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if LWIP_MDNS_RESPONDER
+
+/* Domain methods - also visible for unit tests */
+
+err_t mdns_domain_add_label(struct mdns_domain *domain, const char *label, u8_t len);
+u16_t mdns_readname(struct pbuf *p, u16_t offset, struct mdns_domain *domain);
+void mdns_domain_debug_print(struct mdns_domain *domain);
+int mdns_domain_eq(struct mdns_domain *a, struct mdns_domain *b);
+#if LWIP_IPV4
+err_t mdns_build_reverse_v4_domain(struct mdns_domain *domain, const ip4_addr_t *addr);
+#endif
+#if LWIP_IPV6
+err_t mdns_build_reverse_v6_domain(struct mdns_domain *domain, const ip6_addr_t *addr);
+#endif
+err_t mdns_build_host_domain(struct mdns_domain *domain, struct mdns_host *mdns);
+err_t mdns_build_dnssd_domain(struct mdns_domain *domain);
+err_t mdns_build_service_domain(struct mdns_domain *domain, struct mdns_service *service, int include_name);
+u16_t mdns_compress_domain(struct pbuf *pbuf, u16_t *offset, struct mdns_domain *domain);
+err_t mdns_write_domain(struct mdns_outpacket *outpkt, struct mdns_domain *domain);
+
+#endif /* LWIP_MDNS_RESPONDER */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* LWIP_HDR_APPS_MDNS_DOMAIN_H */
diff --git a/src/include/lwip/apps/mdns_opts.h b/src/include/lwip/apps/mdns_opts.h
index ac2322007..d805e8c7a 100644
--- a/src/include/lwip/apps/mdns_opts.h
+++ b/src/include/lwip/apps/mdns_opts.h
@@ -32,6 +32,7 @@
  * This file is part of the lwIP TCP/IP stack.
  *
  * Author: Erik Ekman <erik@kryo.se>
+ * Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
  *
  */
 
diff --git a/src/include/lwip/apps/mdns_out.h b/src/include/lwip/apps/mdns_out.h
new file mode 100644
index 000000000..f36eeeda8
--- /dev/null
+++ b/src/include/lwip/apps/mdns_out.h
@@ -0,0 +1,121 @@
+/**
+ * @file
+ * MDNS responder - output related functionalities
+ */
+
+ /*
+ * Copyright (c) 2015 Verisure Innovation AB
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without modification,
+ * are permitted provided that the following conditions are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ *    this list of conditions and the following disclaimer in the documentation
+ *    and/or other materials provided with the distribution.
+ * 3. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
+ * SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
+ * OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
+ * OF SUCH DAMAGE.
+ *
+ * This file is part of the lwIP TCP/IP stack.
+ *
+ * Author: Erik Ekman <erik@kryo.se>
+ * Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
+ *
+ */
+
+#ifndef LWIP_HDR_APPS_MDNS_OUT_H
+#define LWIP_HDR_APPS_MDNS_OUT_H
+
+#include "lwip/apps/mdns_opts.h"
+#include "lwip/apps/mdns_priv.h"
+#include "lwip/netif.h"
+#include "lwip/timeouts.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if LWIP_MDNS_RESPONDER
+
+/** Bitmasks outmsg generation */
+/* Probe for ALL types with hostname */
+#define QUESTION_PROBE_HOST_ANY          0x10
+/* Probe for ALL types with service instance name */
+#define QUESTION_PROBE_SERVICE_NAME_ANY  0x10
+
+/* Lookup from hostname -> IPv4 */
+#define REPLY_HOST_A            0x01
+/* Lookup from IPv4/v6 -> hostname */
+#define REPLY_HOST_PTR_V4       0x02
+/* Lookup from hostname -> IPv6 */
+#define REPLY_HOST_AAAA         0x04
+/* Lookup from hostname -> IPv6 */
+#define REPLY_HOST_PTR_V6       0x08
+
+/* Lookup for service types */
+#define REPLY_SERVICE_TYPE_PTR  0x10
+/* Lookup for instances of service */
+#define REPLY_SERVICE_NAME_PTR  0x20
+/* Lookup for location of service instance */
+#define REPLY_SERVICE_SRV       0x40
+/* Lookup for text info on service instance */
+#define REPLY_SERVICE_TXT       0x80
+
+/* RFC6762 section 6:
+ * To protect the network against excessive packet flooding due to software bugs
+ * or malicious attack, a Multicast DNS responder MUST NOT (except in the one
+ * special case of answering probe queries) multicast a record on a given
+ * interface until at least one second has elapsed since the last time that
+ * record was multicast on that particular interface.
+ */
+#define MDNS_MULTICAST_TIMEOUT    1000
+
+/* RFC6762 section 5.4:
+ * When receiving a question with the unicast-response bit set, a responder
+ * SHOULD usually respond with a unicast packet directed back to the querier.
+ * However, if the responder has not multicast that record recently (within one
+ * quarter of its TTL), then the responder SHOULD instead multicast the response
+ * so as to keep all the peer caches up to date, and to permit passive conflict
+ * detection.
+ * -> we implement a stripped down version. Depending on a timeout of 30s
+ *    (25% of 120s) all QU questions are send via multicast or unicast.
+ */
+#define MDNS_MULTICAST_TIMEOUT_25TTL  30000
+
+err_t mdns_send_outpacket(struct mdns_outmsg *msg, struct netif *netif);
+void mdns_set_timeout(struct netif *netif, u32_t msecs,
+                        sys_timeout_handler handler, u8_t *busy_flag);
+#if LWIP_IPV4
+void mdns_multicast_timeout_reset_ipv4(void *arg);
+void mdns_multicast_timeout_25ttl_reset_ipv4(void *arg);
+void mdns_send_multicast_msg_delayed_ipv4(void *arg);
+void mdns_send_unicast_msg_delayed_ipv4(void *arg);
+#endif
+#if LWIP_IPV6
+void mdns_multicast_timeout_reset_ipv6(void *arg);
+void mdns_multicast_timeout_25ttl_reset_ipv6(void *arg);
+void mdns_send_multicast_msg_delayed_ipv6(void *arg);
+void mdns_send_unicast_msg_delayed_ipv6(void *arg);
+#endif
+void mdns_prepare_txtdata(struct mdns_service *service);
+
+#endif /* LWIP_MDNS_RESPONDER */
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* LWIP_HDR_APPS_MDNS_OUT_H */
diff --git a/src/include/lwip/apps/mdns_priv.h b/src/include/lwip/apps/mdns_priv.h
index 9635b5b10..23f015dd1 100644
--- a/src/include/lwip/apps/mdns_priv.h
+++ b/src/include/lwip/apps/mdns_priv.h
@@ -32,11 +32,13 @@
  * This file is part of the lwIP TCP/IP stack.
  *
  * Author: Erik Ekman <erik@kryo.se>
+ * Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
  *
  */
 #ifndef LWIP_HDR_MDNS_PRIV_H
 #define LWIP_HDR_MDNS_PRIV_H
 
+#include "lwip/apps/mdns.h"
 #include "lwip/apps/mdns_opts.h"
 #include "lwip/pbuf.h"
 
@@ -46,10 +48,23 @@ extern "C" {
 
 #if LWIP_MDNS_RESPONDER
 
-/* Domain struct and methods - visible for unit tests */
-
 #define MDNS_DOMAIN_MAXLEN 256
 #define MDNS_READNAME_ERROR 0xFFFF
+#define NUM_DOMAIN_OFFSETS 10
+
+#define SRV_PRIORITY 0
+#define SRV_WEIGHT   0
+
+/* mDNS TTL: (RFC6762 section 10)
+ *  - 120 seconds if the hostname appears somewhere in the RR
+ *  - 75 minutes if not (4500 seconds)
+ *  - 10 seconds if responding to a legacy query
+ */
+#define MDNS_TTL_10    10
+#define MDNS_TTL_120   120
+#define MDNS_TTL_4500  4500
+
+/* Domain structs - also visible for unit tests */
 
 struct mdns_domain {
   /* Encoded domain name */
@@ -60,10 +75,110 @@ struct mdns_domain {
   u8_t skip_compression;
 };
 
-err_t mdns_domain_add_label(struct mdns_domain *domain, const char *label, u8_t len);
-u16_t mdns_readname(struct pbuf *p, u16_t offset, struct mdns_domain *domain);
-int mdns_domain_eq(struct mdns_domain *a, struct mdns_domain *b);
-u16_t mdns_compress_domain(struct pbuf *pbuf, u16_t *offset, struct mdns_domain *domain);
+/** Description of a service */
+struct mdns_service {
+  /** TXT record to answer with */
+  struct mdns_domain txtdata;
+  /** Name of service, like 'myweb' */
+  char name[MDNS_LABEL_MAXLEN + 1];
+  /** Type of service, like '_http' */
+  char service[MDNS_LABEL_MAXLEN + 1];
+  /** Callback function and userdata
+   * to update txtdata buffer */
+  service_get_txt_fn_t txt_fn;
+  void *txt_userdata;
+  /** Protocol, TCP or UDP */
+  u16_t proto;
+  /** Port of the service */
+  u16_t port;
+};
+
+/** mDNS output packet */
+struct mdns_outpacket {
+  /** Packet data */
+  struct pbuf *pbuf;
+  /** Current write offset in packet */
+  u16_t write_offset;
+  /** Number of questions written */
+  u16_t questions;
+  /** Number of normal answers written */
+  u16_t answers;
+  /** Number of authoritative answers written */
+  u16_t authoritative;
+  /** Number of additional answers written */
+  u16_t additional;
+  /** Offsets for written domain names in packet.
+   *  Used for compression */
+  u16_t domain_offsets[NUM_DOMAIN_OFFSETS];
+};
+
+/** mDNS output message */
+struct mdns_outmsg {
+  /** Identifier. Used in legacy queries */
+  u16_t tx_id;
+  /** dns flags */
+  u8_t flags;
+  /** Destination IP/port if sent unicast */
+  ip_addr_t dest_addr;
+  u16_t dest_port;
+  /** If all answers in packet should set cache_flush bit */
+  u8_t cache_flush;
+  /** If reply should be sent unicast (as requested) */
+  u8_t unicast_reply_requested;
+  /** If legacy query. (tx_id needed, and write
+   *  question again in reply before answer) */
+  u8_t legacy_query;
+  /** If the query is a probe msg we need to respond immediatly. Independent of
+   *  the QU or QM flag. */
+  u8_t probe_query_recv;
+  /* Question bitmask for host information */
+  u8_t host_questions;
+  /* Questions bitmask per service */
+  u8_t serv_questions[MDNS_MAX_SERVICES];
+  /* Reply bitmask for host information */
+  u8_t host_replies;
+  /* Bitmask for which reverse IPv6 hosts to answer */
+  u8_t host_reverse_v6_replies;
+  /* Reply bitmask per service */
+  u8_t serv_replies[MDNS_MAX_SERVICES];
+};
+
+/** Delayed msg info */
+struct mdns_delayed_msg {
+  /** Timer state multicast */
+  u8_t multicast_msg_waiting;
+  /** Multicast timeout on */
+  u8_t multicast_timeout;
+  /** Output msg used for delayed multicast responses */
+  struct mdns_outmsg delayed_msg_multicast;
+  /** Prefer multicast over unicast timeout -> 25% of TTL = we take 30s as
+      general delay. */
+  u8_t multicast_timeout_25TTL;
+  /** Only send out new unicast message if previous was send */
+  u8_t unicast_msg_in_use;
+  /** Output msg used for delayed unicast responses */
+  struct mdns_outmsg delayed_msg_unicast;
+};
+
+/** Description of a host/netif */
+struct mdns_host {
+  /** Hostname */
+  char name[MDNS_LABEL_MAXLEN + 1];
+  /** Pointer to services */
+  struct mdns_service *services[MDNS_MAX_SERVICES];
+  /** Number of probes sent for the current name */
+  u8_t probes_sent;
+  /** State in probing sequence */
+  u8_t probing_state;
+#if LWIP_IPV4
+  /** delayed msg struct for IPv4 */
+  struct mdns_delayed_msg ipv4;
+#endif
+#if LWIP_IPV6
+  /** delayed msg struct for IPv6 */
+  struct mdns_delayed_msg ipv6;
+#endif
+};
 
 #endif /* LWIP_MDNS_RESPONDER */
 
diff --git a/test/unit/mdns/test_mdns.c b/test/unit/mdns/test_mdns.c
index 638516370..5a630f478 100644
--- a/test/unit/mdns/test_mdns.c
+++ b/test/unit/mdns/test_mdns.c
@@ -34,6 +34,7 @@
 
 #include "lwip/pbuf.h"
 #include "lwip/apps/mdns.h"
+#include "lwip/apps/mdns_domain.h"
 #include "lwip/apps/mdns_priv.h"
 
 START_TEST(readname_basic)
-- 
2.19.1

